﻿Imports System.Drawing
Imports System.IO
Imports System
Imports System.Windows.Forms

'ein TestForm fürs gleichzeitige Entwickeln mehrerer Forms. In New() kann man die in Arbeit befindlichen Forms "einfüllen", und zur Laufzeit kannman sie dann zu- und weg- schalten nach Belieben.
Partial Public Class frmMDI : Inherits Form

   Dim _FormTypes As Type() = New Type() { _
         GetType(Form), _
         GetType(Form), _
         GetType(Form), _
         GetType(Form) _
         }


#Region "MDI-Stuff"

   Private _Settings As String = "Settings.txt"

   Public Sub New()
      InitializeComponent()
      'volle Screen-Breite - aber nicht volle Höhe (Platz lassen fürs Output-Window der IDE)
      Dim rct = Screen.PrimaryScreen.WorkingArea
      rct.Height = Me.Height
      Me.Bounds = rct
      'hier werden die ChildForms "eingefüllt"
      lstChildForms.DataSource = _FormTypes
      AddHandler lstChildForms.ItemCheck, AddressOf lstChildForms_ItemCheck
      If File.Exists(_Settings) Then
         'Indizees der sofort anzuzeigenden Forms aus den Settings lesen
         Dim indx = _
            From s In File.ReadAllText(_Settings) _
            .Split(New Char() {" "c}, StringSplitOptions.RemoveEmptyEntries) _
            Let i = Integer.Parse(s) _
            Where i < lstChildForms.Items.Count _
            Select i
         For Each i In indx.Reverse()
            lstChildForms.SetItemChecked(i, True)
         Next
      End If
      AddHandler lstChildForms.SelectedIndexChanged, AddressOf lstChildForms_SelectedIndexChanged
   End Sub

   Private Sub lstChildForms_ItemCheck(ByVal sender As Object, ByVal e As ItemCheckEventArgs)
      ' checken/unchecken öffnet/schließt das entsprechende Form
      Dim tpChild = DirectCast(lstChildForms.Items(e.Index), Type)
      If e.NewValue = CheckState.Checked Then
         Dim frm = DirectCast(Activator.CreateInstance(tpChild), Form)
         frm.MdiParent = Me
         'if (frm.MainMenuStrip != null) frm.MainMenuStrip.Hide();
         frm.WindowState = FormWindowState.Maximized
         AddHandler frm.Disposed, AddressOf frm_Disposed
         frm.Show()
      Else
         Me.MdiChildren.First(Function(f As Form) f.[GetType]().Equals(tpChild)).Close()
      End If
   End Sub

   Private Sub frm_Disposed(ByVal sender As Object, ByVal e As EventArgs)
      RemoveHandler lstChildForms.ItemCheck, AddressOf lstChildForms_ItemCheck
      Dim tps = DirectCast(lstChildForms.DataSource, Type())
      lstChildForms.SetItemChecked(tps.IndexOf(sender.GetType()), False)
      AddHandler lstChildForms.ItemCheck, AddressOf lstChildForms_ItemCheck
   End Sub

   Private Sub lstChildForms_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
      ' Das selected Item - Form nach vorn bringen.
      Dim lst = DirectCast(sender, CheckedListBox)
      If lst.GetItemChecked(lst.SelectedIndex) Then
         MdiChildren.First(Function(c As Form) c.[GetType]().Equals(lst.SelectedValue)).BringToFront()
      End If
   End Sub

   Private Sub lstChildForms_Format(ByVal sender As Object, ByVal e As ListControlConvertEventArgs) Handles lstChildForms.Format
      e.Value = DirectCast(e.ListItem, Type).Name
   End Sub

   Private Sub frmMDIParentForm_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
      SaveSettings()
   End Sub
   Private Sub SaveSettings()
      File.WriteAllText(_Settings, String.Join(" ", lstChildForms.CheckedIndices.Cast(Of Integer)().Select(Function(i) i.ToString()).ToArray()))
   End Sub

#End Region 'MDI-Stuff

End Class
