﻿Namespace System

   Public Module modCreators

      Public Function NewStack(Of T)(ByVal Entries As IEnumerable(Of T)) As Stack(Of T)
         Return New Stack(Of T)(Entries)
      End Function

      Public Function NewKeyValue(Of TKey, TValue)(ByVal Key As TKey, ByVal Value As TValue) _
              As KeyValuePair(Of TKey, TValue)
         Return New KeyValuePair(Of TKey, TValue)(Key, Value)
      End Function

      Public Function NewSet(Of Ta)(ByVal a As Ta) As [Set](Of Ta)
         Return New [Set](Of Ta) With {.A = a}
      End Function
      Public Function NewSet(Of Ta, Tb)(ByVal a As Ta, ByVal b As Tb) As [Set](Of Ta, Tb)
         Return New [Set](Of Ta, Tb) With {.A = a, .B = b}
      End Function
      Public Function NewSet(Of Ta, Tb, Tc)(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc) _
            As [Set](Of Ta, Tb, Tc)
         Return New [Set](Of Ta, Tb, Tc) With {.A = a, .B = b, .C = c}
      End Function
      Public Function NewSet(Of Ta, Tb, Tc, Td)( _
            ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td) As [Set](Of Ta, Tb, Tc, Td)
         Return New [Set](Of Ta, Tb, Tc, Td) With {.A = a, .B = b, .C = c, .D = d}
      End Function
      Public Function NewSet(Of Ta, Tb, Tc, Td, Te)( _
            ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td, ByVal e As Te) _
            As [Set](Of Ta, Tb, Tc, Td, Te)
         Return New [Set](Of Ta, Tb, Tc, Td, Te) With { _
            .A = a, .B = b, .C = c, .D = d, .E = e}
      End Function
      Public Function NewSet(Of Ta, Tb, Tc, Td, Te, Tf)( _
            ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td, ByVal e As Te, ByVal f As Tf) _
            As [Set](Of Ta, Tb, Tc, Td, Te, Tf)
         Return New [Set](Of Ta, Tb, Tc, Td, Te, Tf) With { _
            .A = a, .B = b, .C = c, .D = d, .E = e, .F = f}
      End Function

   End Module
End Namespace
